/*
madman - a music manager
Copyright (C) 2003  Andreas Kloeckner <ak@ixion.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/




#ifndef BASE
#define BASE




#include <iostream>
#include <string>
#include <qstring.h>
#include <qstringlist.h>
#include <qobject.h>
#include <qdatetime.h>

#include <vector>
#if __GNUC__ >= 3 
#include <ext/hash_map>
#include <ext/hash_set>
#else
#include <hash_map>
#include <hash_set>
#endif

#include "config.h"




using namespace std;
#if __GNUC__ >= 3 
using __gnu_cxx::hash_map;
using __gnu_cxx::hash_set;
#endif



#define MADMAN_VERSION		VERSION




class tSong;




typedef int tUniqueId;
typedef unsigned tIndex;
typedef QString tFilename;
typedef vector<tFilename> tDirectoryList;
typedef vector<tSong *> tSongList;
typedef vector<tUniqueId> tUniqueIdList;
typedef hash_set<tUniqueId> tUniqueIdSet;








#define FOREACH(VAR,LIST,LISTTYPE) \
  for (LISTTYPE::iterator VAR = (LIST).begin(),last = (LIST).end();VAR != last;VAR++)
#define FOREACH_CONST(VAR,LIST,LISTTYPE) \
  for (LISTTYPE::const_iterator VAR = (LIST).begin(),last = (LIST).end();VAR != last;VAR++)




bool hasAttribute( const char *name, const char **attributes );
QString lookupAttribute( const char *name, const char **attributes );

string QString2string( QString const &str );
QString string2QString( string const &str );
QString wstring2QString( const wchar_t *str );
vector<QString> QStringList2QStringvector( const QStringList &strlist );
QStringList QStringvector2QStringList( const vector<QString> &strlist );
ostream &operator <<( ostream &ostr, QString const &str );
void runtimeError( QString const &str );



class hash_QString
{
  public:
    unsigned long operator() ( QString const &str ) const;
};

class tProfiler
{
    QTime		Time;
    QString	Name;

  public:
    tProfiler( const QString &name = "" );
    ~tProfiler();
};



#endif
