/*
madman - a music manager
Copyright (C) 2003  Andreas Kloeckner <ak@ixion.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/




#ifndef HEADER_SEEN_PREFS_H
#define HEADER_SEEN_PREFS_H




#include <vector>
#include "utility/base.h"




class tPlayer;
class tMainWindow;
class QSettings;




struct tAutoDJPreferences 
{
  int PlayRatioUnrated;
  int PlayRatio5Rated, PlayRatio4Rated, PlayRatio3Rated, PlayRatio2Rated;
  int PlayRatio1Rated, PlayRatio0Rated;
  int PlayRatioUnplayed;
  int PlayRatioOftenPlayed;
  int PlayRatioRarelyPlayed;
  int PlayRatioRandom;
  int PlayRatioUnratedByGoodArtist;
};

struct tPreferences
{
  bool RememberGeometry;
  bool ScanAtStartup;
  bool CollectHistory;
  bool UseFuzzySearch;

  int BackupCount;

  tPlayer *Player;
  tDirectoryList PluginDirectories;

  vector<bool> ColumnVisibility;

  bool HttpDaemonEnabled;
  int HttpDaemonPort;
  bool HttpDownloadsEnabled;
  bool HttpScriptingEnabled;
  bool HttpWriteScriptingEnabled;
  bool HttpLocalPlayEnabled;
  bool HttpBrowsingEnabled;

  tAutoDJPreferences AutoDJPreferences;

  tPreferences()
  {
    Player = NULL;
  }

  void save( QSettings &settings );
  void load( QSettings &settings );

  void setPlayer( tPlayer *newplayer );
};




#endif
